

class Job(object):
	pass

class Pool(object):
	r"""Base class for orchestrating computation of an expensive function
	"""
	def apply(self, f, args = None, kwargs = None):
		r"""
		"""
		if args is None: args = ()
		if kwargs is None:	kwargs = {}
		 


class SequentialJob(Job):
	def __init__(self, f, args = None, kwargs = None):
		self.f = f
		if args is None: args = ()
		if kwargs is None:	kwargs = {}
		self.args = args
		self.kwargs = kwargs
		self.output = f(*args, **kwargs)

		
	def ready(self):
		return True


class SequentialPool(Pool):
	def apply(self, f, args = None, kwargs = None):
		if args is None: args = ()
		if kwargs is None:	kwargs = {}
		return SequentialJob(f, args, kwargs)

	def avail_workers(self):
		return 1
	
	def join(self):
		""" wait until all tasks done
		"""
		# Since the SequentialPool runs all jobs immediately, simply stop
		pass
